com.oracle.truffle.api

## Class TruffleOptions

- java.lang.Object
- - com.oracle.truffle.api.TruffleOptions

    public class TruffleOptions
    extends java.lang.Object

Class containing general Truffle options.

### Field Summary

Fields
`static boolean` `DetailedRewriteReasons` Enables the generation of detailed rewrite reasons.
`static boolean` `TraceASTJSON` Enables the dumping of Node creations and AST rewrites in JSON format.
`static boolean` `TraceRewrites` Enables/disables the rewriting of traces in the Truffle runtime to stdout.
`static java.lang.String` `TraceRewritesFilterClass` Filters rewrites that do not contain the given string in the qualified name of the source or target class hierarchy.
`static NodeCost` `TraceRewritesFilterFromCost` Filters rewrites which does not contain the `NodeCost` in its source `NodeInfo`.
`static NodeCost` `TraceRewritesFilterToCost` Filters rewrites which does not contain the `NodeCost` in its target `NodeInfo`.

### Constructor Summary

Constructors
Constructor and Description
`TruffleOptions()`

### Method Summary

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### TraceRewrites

    public static boolean TraceRewrites

Enables/disables the rewriting of traces in the Truffle runtime to stdout.

Can be set with `-Dtruffle.TraceRewrites=true`.

#### DetailedRewriteReasons

    public static final boolean DetailedRewriteReasons

Enables the generation of detailed rewrite reasons. Enabling this may introduce some overhead for rewriting nodes.

Can be set with `-Dtruffle.DetailedRewriteReasons=true`.

#### TraceRewritesFilterClass

    public static java.lang.String TraceRewritesFilterClass

Filters rewrites that do not contain the given string in the qualified name of the source or target class hierarchy.

Can be set with `-Dtruffle.TraceRewritesFilterClass=name`.

#### TraceRewritesFilterFromCost

    public static NodeCost TraceRewritesFilterFromCost

Filters rewrites which does not contain the `NodeCost` in its source `NodeInfo`. If no `NodeInfo` is defined the element is filtered if the filter value is set.

Can be set with `-Dtruffle.TraceRewritesFilterFromCost=NONE|MONOMORPHIC|POLYMORPHIC|MEGAMORPHIC`.

#### TraceRewritesFilterToCost

    public static NodeCost TraceRewritesFilterToCost

Filters rewrites which does not contain the `NodeCost` in its target `NodeInfo`. If no `NodeInfo` is defined the element is filtered if the filter value is set.

Can be set with `-Dtruffle.TraceRewritesFilterToKind=UNINITIALIZED|SPECIALIZED|POLYMORPHIC|GENERIC`.

#### TraceASTJSON

    public static final boolean TraceASTJSON

Enables the dumping of Node creations and AST rewrites in JSON format.

Can be set with `-Dtruffle.TraceASTJSON=true`.

### Constructor Detail

#### TruffleOptions

    public TruffleOptions()